"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var nextUniqueId = 0;
exports.CHECKBOX_OPTION_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return CheckBoxOptionComponent; }),
    multi: true
};
var CheckBoxDirective = (function () {
    function CheckBoxDirective() {
        this.cellsC = true;
        this.checkboxC = true;
    }
    __decorate([
        core_1.HostBinding('class.weui-cells'),
        __metadata("design:type", Boolean)
    ], CheckBoxDirective.prototype, "cellsC", void 0);
    __decorate([
        core_1.HostBinding('class.weui-cells_checkbox'),
        __metadata("design:type", Boolean)
    ], CheckBoxDirective.prototype, "checkboxC", void 0);
    CheckBoxDirective = __decorate([
        core_1.Directive({
            selector: 'div[ye-checkbox]'
        })
    ], CheckBoxDirective);
    return CheckBoxDirective;
}());
exports.CheckBoxDirective = CheckBoxDirective;
var CheckBoxOptionComponent = (function () {
    function CheckBoxOptionComponent(_changeDetectorRef) {
        this._changeDetectorRef = _changeDetectorRef;
        this.type = '';
        this.change = new core_1.EventEmitter();
        this.id = "ye-checkbox-option-" + ++nextUniqueId;
        this.name = this.id;
        this.cellC = true;
        this.labelA = true;
        this._checked = false;
        this._controlValueAccessorChangeFn = function () { };
        this.onTouched = function () { };
    }
    Object.defineProperty(CheckBoxOptionComponent.prototype, "checked", {
        get: function () {
            return this._checked;
        },
        set: function (checked) {
            if (checked !== this.checked) {
                this._checked = checked;
                this._changeDetectorRef.markForCheck();
            }
        },
        enumerable: true,
        configurable: true
    });
    CheckBoxOptionComponent.prototype.writeValue = function (value) {
        this.checked = !!value;
    };
    CheckBoxOptionComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    CheckBoxOptionComponent.prototype.registerOnChange = function (fn) {
        this._controlValueAccessorChangeFn = fn;
    };
    CheckBoxOptionComponent.prototype.ignoreInputChange = function (event) {
        event.stopPropagation();
    };
    CheckBoxOptionComponent.prototype.ignoreInputClick = function (event) {
        event.stopPropagation();
        this.checked = !this.checked;
        this._controlValueAccessorChangeFn(this.checked);
        this.change.emit(this.checked);
    };
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], CheckBoxOptionComponent.prototype, "change", void 0);
    __decorate([
        core_1.HostBinding('attr.for'),
        __metadata("design:type", String)
    ], CheckBoxOptionComponent.prototype, "id", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], CheckBoxOptionComponent.prototype, "name", void 0);
    __decorate([
        core_1.HostBinding('class.weui-cell'),
        __metadata("design:type", Boolean)
    ], CheckBoxOptionComponent.prototype, "cellC", void 0);
    __decorate([
        core_1.HostBinding('class.weui-check__label'),
        __metadata("design:type", Boolean)
    ], CheckBoxOptionComponent.prototype, "labelA", void 0);
    CheckBoxOptionComponent = __decorate([
        core_1.Component({
            selector: 'label[ye-checkbox-option]',
            template: "\n    <div class=\"weui-cell__hd\"><input [id]=\"id\" type=\"checkbox\" [attr.name]=\"name\" (change)=\"ignoreInputChange($event)\"\n    (click)=\"ignoreInputClick($event)\" [checked]=\"checked\" class=\"weui-check\" /><i class=\"weui-icon-checked\"></i></div>\n    <div class=\"weui-cell__bd\"><p style=\"margin: 0;\"><ng-content></ng-content></p></div>",
            providers: [exports.CHECKBOX_OPTION_CONTROL_VALUE_ACCESSOR],
            changeDetection: core_1.ChangeDetectionStrategy.OnPush,
            encapsulation: core_1.ViewEncapsulation.None
        }),
        __metadata("design:paramtypes", [core_1.ChangeDetectorRef])
    ], CheckBoxOptionComponent);
    return CheckBoxOptionComponent;
}());
exports.CheckBoxOptionComponent = CheckBoxOptionComponent;
//# sourceMappingURL=checkbox.js.map