"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var nextUniqueId = 0;
exports.RADIO_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return RadioDirective; }),
    multi: true
};
var RadioDirective = (function () {
    function RadioDirective() {
        this.change = new core_1.EventEmitter();
        this.cellsC = true;
        this.radioC = true;
        this._controlValueAccessorChangeFn = function () { };
        this.onTouched = function () { };
    }
    RadioDirective.prototype._optionChange = function (optionId) {
        var _this = this;
        if (!this.options) {
            return;
        }
        if (optionId === this.currentId) {
            return;
        }
        this.options.forEach(function (o, i) {
            if (o.id === optionId) {
                _this.chosen = o.value || i;
                _this._controlValueAccessorChangeFn(_this.chosen);
                _this.change.emit(_this.chosen);
                _this.currentId = optionId;
                o._setOn();
            }
            else {
                o._setOff();
            }
        });
    };
    RadioDirective.prototype.writeValue = function (value) {
        var _this = this;
        if (!this.options) {
            return;
        }
        this.options.forEach(function (o, i) {
            if (value === o.value || (!o.value && value === i)) {
                _this.chosen = value;
                _this.currentId = o.id;
                o._setOn();
            }
            else {
                o._setOff();
            }
        });
    };
    RadioDirective.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    RadioDirective.prototype.registerOnChange = function (fn) {
        this._controlValueAccessorChangeFn = fn;
    };
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], RadioDirective.prototype, "change", void 0);
    __decorate([
        core_1.HostBinding('class.weui-cells'),
        __metadata("design:type", Boolean)
    ], RadioDirective.prototype, "cellsC", void 0);
    __decorate([
        core_1.HostBinding('class.weui-cells_radio'),
        __metadata("design:type", Boolean)
    ], RadioDirective.prototype, "radioC", void 0);
    __decorate([
        core_1.ContentChildren(core_1.forwardRef(function () { return RadioOptionComponent; }), { descendants: true }),
        __metadata("design:type", core_1.QueryList)
    ], RadioDirective.prototype, "options", void 0);
    RadioDirective = __decorate([
        core_1.Directive({
            selector: 'div[ye-radio]',
            providers: [exports.RADIO_CONTROL_VALUE_ACCESSOR]
        })
    ], RadioDirective);
    return RadioDirective;
}());
exports.RadioDirective = RadioDirective;
var RadioOptionComponent = (function () {
    function RadioOptionComponent(_changeDetectorRef, radioD) {
        this._changeDetectorRef = _changeDetectorRef;
        this.radioD = radioD;
        this.id = "ye-radio-option-" + ++nextUniqueId;
        this.cellC = true;
        this.labelA = true;
        this._checked = false;
    }
    Object.defineProperty(RadioOptionComponent.prototype, "checked", {
        get: function () {
            return this._checked;
        },
        set: function (checked) {
            if (checked !== this.checked) {
                this._checked = checked;
                this._changeDetectorRef.markForCheck();
            }
        },
        enumerable: true,
        configurable: true
    });
    RadioOptionComponent.prototype.ignoreInputChange = function (event) {
        event.stopPropagation();
    };
    RadioOptionComponent.prototype.ignoreInputClick = function (event) {
        event.stopPropagation();
        if (this.radioD) {
            this.radioD._optionChange(this.id);
        }
    };
    RadioOptionComponent.prototype._setOff = function () {
        this.checked = false;
    };
    RadioOptionComponent.prototype._setOn = function () {
        this.checked = true;
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], RadioOptionComponent.prototype, "name", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], RadioOptionComponent.prototype, "value", void 0);
    __decorate([
        core_1.HostBinding('attr.for'),
        __metadata("design:type", String)
    ], RadioOptionComponent.prototype, "id", void 0);
    __decorate([
        core_1.HostBinding('class.weui-cell'),
        __metadata("design:type", Boolean)
    ], RadioOptionComponent.prototype, "cellC", void 0);
    __decorate([
        core_1.HostBinding('class.weui-check__label'),
        __metadata("design:type", Boolean)
    ], RadioOptionComponent.prototype, "labelA", void 0);
    RadioOptionComponent = __decorate([
        core_1.Component({
            selector: 'label[ye-radio-option]',
            template: "\n    <div class=\"weui-cell__bd\"><p style=\"margin: 0;\"><ng-content></ng-content></p></div>\n    <div class=\"weui-cell__ft\"><input [id]=\"id\" type=\"radio\" [attr.name]=\"name\" (change)=\"ignoreInputChange($event)\"\n    (click)=\"ignoreInputClick($event)\" [checked]=\"checked\" class=\"weui-check\" /><i class=\"weui-icon-checked\"></i></div>\n    ",
            changeDetection: core_1.ChangeDetectionStrategy.OnPush,
            encapsulation: core_1.ViewEncapsulation.None
        }),
        __param(1, core_1.Optional()),
        __metadata("design:paramtypes", [core_1.ChangeDetectorRef,
            RadioDirective])
    ], RadioOptionComponent);
    return RadioOptionComponent;
}());
exports.RadioOptionComponent = RadioOptionComponent;
//# sourceMappingURL=radio.js.map