"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var animations_1 = require("@angular/animations");
exports.mask = animations_1.trigger('mask', [
    animations_1.state('enter', animations_1.style({ opacity: 0.7 })),
    animations_1.state('void', animations_1.style({ opacity: 0 })),
    animations_1.state('exit', animations_1.style({ opacity: 0 })),
    animations_1.transition('* => *', animations_1.animate('0.3s linear'))
]);
exports.dialog = animations_1.trigger('dialog', [
    animations_1.state('enter', animations_1.style({
        'opacity': '1',
        '-webkit-transform': 'translate(-50%, -50%) scale(1)',
        'transform': 'translate(-50%, -50%) scale(1)'
    })),
    animations_1.state('void', animations_1.style({
        'opacity': '0',
        '-webkit-transform': 'translate(-50%, -50%) scale(1.2)',
        'transform': 'translate(-50%, -50%) scale(1.2)'
    })),
    animations_1.state('exit', animations_1.style({
        'opacity': '0',
        '-webkit-transform': 'translate(-50%, -50%) scale(0.8)',
        'transform': 'translate(-50%, -50%) scale(0.8)'
    })),
    animations_1.transition('* => *', [
        animations_1.animate('0.3s linear')
    ])
]);
exports.load = animations_1.trigger('load', [
    animations_1.state('enter', animations_1.style({
        'opacity': '1',
        '-webkit-transform': 'translateY(0)',
        'transform': 'translateY(0)'
    })),
    animations_1.state('exit', animations_1.style({
        'opacity': '0',
        '-webkit-transform': 'translateY(20%)',
        'transform': 'translateY(20%)'
    })),
    animations_1.state('void', animations_1.style({
        'opacity': '0',
        '-webkit-transform': 'translateY(20%)',
        'transform': 'translateY(20%)'
    })),
    animations_1.transition('* => *', animations_1.animate('0.3s ease-in'))
]);
exports.toast = animations_1.trigger('toast', [
    animations_1.state('enter', animations_1.style({
        'opacity': '1',
        '-webkit-transform': 'translate(-50%, 0)',
        'transform': 'translate(-50%, 0)'
    })),
    animations_1.state('exit', animations_1.style({
        'opacity': '0',
        '-webkit-transform': 'translate(-50%, 50%)',
        'transform': 'translate(-50%, 50%)'
    })),
    animations_1.state('void', animations_1.style({
        'opacity': '0',
        '-webkit-transform': 'translate(-50%, 50%)',
        'transform': 'translate(-50%, 50%)'
    })),
    animations_1.transition('* => *', animations_1.animate('0.3s ease-in'))
]);
//# sourceMappingURL=animations.js.map