import { Injector, InjectionToken } from '@angular/core';
export interface ComponentType<T> {
    new (...args: any[]): T;
}
export declare class PortalInjector implements Injector {
    private _parentInjector;
    private _customTokens;
    constructor(_parentInjector: Injector, _customTokens: WeakMap<any, any>);
    get(token: any, notFoundValue?: any): any;
}
export interface ContainerConfig {
    background?: 'transition' | 'mask' | 'strict' | 'none' | 'loose';
}
export interface Config extends ContainerConfig {
    data?: any;
}
export interface CustomConfig extends Config {
    radius?: string;
    size?: string[2];
    scroll?: string[2];
}
export interface DialogConfig extends ContainerConfig {
    showCancel?: boolean;
    title?: string;
    body?: string;
    ok?: string;
    no?: string;
}
export interface ToastConfig extends Config {
    body?: string;
    delay?: number;
    duration?: number;
}
export interface LoadConfig extends Config {
    body?: string;
    delay?: number;
    duration?: number;
    type?: 'load' | 'success';
}
export declare const CONTAINER_DATA: InjectionToken<any>;
export declare const DIALOG_DATA: InjectionToken<any>;
export declare const TOAST_DATA: InjectionToken<any>;
export declare const LOAD_DATA: InjectionToken<any>;
