"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("../base/common");
var container_host_1 = require("../base/container-host");
var animations_1 = require("../animations");
var DialogContainerComponent = (function () {
    function DialogContainerComponent(viewContainerRef, componentFactoryResolver, changeDetectorRef, data) {
        this.viewContainerRef = viewContainerRef;
        this.componentFactoryResolver = componentFactoryResolver;
        this.changeDetectorRef = changeDetectorRef;
        this.data = data;
        this.animationStateChange = new core_1.EventEmitter();
        this._state = 'enter';
        this.isAnimating = false;
    }
    DialogContainerComponent.prototype.attachComponent = function (component, injector) {
        return this.host.attachComponent(component, injector);
    };
    DialogContainerComponent.prototype._onAnimationDone = function (event) {
        this.animationStateChange.emit(event);
        this.isAnimating = false;
    };
    DialogContainerComponent.prototype._onAnimationStart = function (event) {
        this.isAnimating = true;
        this.animationStateChange.emit(event);
    };
    DialogContainerComponent.prototype._startExitAnimation = function () {
        this._state = 'exit';
        this.changeDetectorRef.markForCheck();
    };
    DialogContainerComponent.prototype.close = function () {
        if (this.data.background === 'mask' || this.data.background === 'loose') {
            this._startExitAnimation();
        }
    };
    __decorate([
        core_1.ViewChild(container_host_1.ContainerHostDirective),
        __metadata("design:type", container_host_1.ContainerHostDirective)
    ], DialogContainerComponent.prototype, "host", void 0);
    DialogContainerComponent = __decorate([
        core_1.Component({
            selector: 'yup-container',
            template: "\n        <div class=\"weui-mask\" [@mask]=\"(data.background === 'transition' || data.background === 'loose') ? 'exit' : _state\" (click)=\"close()\"></div>\n        <div class=\"weui-dialog\" [@dialog]=\"_state\" (@dialog.start)=\"_onAnimationStart($event)\" (@dialog.done)=\"_onAnimationDone($event)\">\n            <ng-template yupHost></ng-template>\n        </div>\n    ",
            encapsulation: core_1.ViewEncapsulation.None,
            changeDetection: core_1.ChangeDetectionStrategy.Default,
            animations: [animations_1.dialog, animations_1.mask]
        }),
        __param(3, core_1.Inject(common_1.CONTAINER_DATA)),
        __metadata("design:paramtypes", [core_1.ViewContainerRef,
            core_1.ComponentFactoryResolver,
            core_1.ChangeDetectorRef, Object])
    ], DialogContainerComponent);
    return DialogContainerComponent;
}());
exports.DialogContainerComponent = DialogContainerComponent;
//# sourceMappingURL=container.js.map