import { Injector } from '@angular/core';
import { ComponentType, DialogConfig, CustomConfig, ToastConfig, LoadConfig } from './base/common';
import { Container } from './base/container';
import { DialogRef } from './dialog/dialog.ref';
import { DialogComponent } from './dialog/template';
import { ToastComponent } from './toast/template';
import { ToastRef } from './toast/toast.ref';
import { LoadComponent } from './load/template';
import { LoadRef } from './load/load.ref';
export declare class YUPService {
    private container;
    private injector;
    constructor(container: Container, injector: Injector);
    dialog(config?: DialogConfig): DialogRef<DialogComponent>;
    alert(config?: DialogConfig): DialogRef<DialogComponent>;
    custom<T>(component: ComponentType<T>, config?: CustomConfig): any;
    load(config?: LoadConfig): LoadRef<LoadComponent>;
    toast(config?: ToastConfig): ToastRef<ToastComponent>;
    private openDialog<T>(component, config);
    private attachDialog<T>(component, containerComponent, containerRef, data?);
    private attachToast<T>(component, containerComponent, containerRef, data?);
    private attachLoad<T>(component, containerComponent, containerRef, data?);
    private createContainerComponent<T>(containerRef, containerComponent, containerConfig);
    private createDialogInjector<T>(config, popupRef, dialogContainer);
    private createToastInjector<T>(config, popupRef, toastContainer);
    private createLoadInjector<T>(config, popupRef, loadContainer);
}
