"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("./base/common");
var container_1 = require("./base/container");
var container_2 = require("./dialog/container");
var dialog_ref_1 = require("./dialog/dialog.ref");
var template_1 = require("./dialog/template");
var template_2 = require("./toast/template");
var toast_ref_1 = require("./toast/toast.ref");
var container_3 = require("./toast/container");
var template_3 = require("./load/template");
var load_ref_1 = require("./load/load.ref");
var container_4 = require("./load/container");
var YUPService = (function () {
    function YUPService(container, injector) {
        this.container = container;
        this.injector = injector;
    }
    YUPService.prototype.dialog = function (config) {
        config = config || {};
        config = {
            title: config.title || '消息',
            body: config.body || ' ',
            ok: config.ok || '确认',
            no: config.no || '取消',
            background: config.background || 'mask',
            showCancel: true
        };
        return this.openDialog(template_1.DialogComponent, config);
    };
    YUPService.prototype.alert = function (config) {
        config = config || {};
        config = {
            title: config.title || '消息',
            body: config.body || ' ',
            ok: config.ok || '确认',
            no: config.no || '取消',
            background: config.background || 'mask',
            showCancel: false
        };
        return this.openDialog(template_1.DialogComponent, config);
    };
    YUPService.prototype.custom = function (component, config) {
        console.log('自定义弹窗能力开发中..');
        return {};
    };
    YUPService.prototype.load = function (config) {
        config = config || {};
        config = {
            body: config.body || ' ',
            background: config.background || 'mask',
            duration: config.duration || 0,
            delay: config.delay || 0,
            type: config.type || 'success'
        };
        var containerRef = this.container.createContainer();
        var containerComponent = this.createContainerComponent(containerRef, container_4.LoadContainerComponent, config);
        var loadRef = this.attachLoad(template_3.LoadComponent, containerComponent, containerRef, config);
        return loadRef;
    };
    YUPService.prototype.toast = function (config) {
        config = config || {};
        config = {
            body: config.body || ' ',
            delay: config.delay || 0,
            duration: config.duration || 0
        };
        var containerRef = this.container.createContainer();
        var containerComponent = this.createContainerComponent(containerRef, container_3.ToastContainerComponent, config);
        var toastRef = this.attachToast(template_2.ToastComponent, containerComponent, containerRef, config);
        return toastRef;
    };
    YUPService.prototype.openDialog = function (component, config) {
        var containerRef = this.container.createContainer();
        var containerComponent = this.createContainerComponent(containerRef, container_2.DialogContainerComponent, { background: config.background });
        var dialogRef = this.attachDialog(component, containerComponent, containerRef, config);
        return dialogRef;
    };
    YUPService.prototype.attachDialog = function (component, containerComponent, containerRef, data) {
        var dialogRef = new dialog_ref_1.DialogRef(containerRef, containerComponent);
        var injector = this.createDialogInjector(data, dialogRef, containerComponent);
        if (containerComponent.attachComponent) {
            var contentRef = containerComponent.attachComponent(component, injector);
            dialogRef.componentInstance = contentRef.instance;
        }
        return dialogRef;
    };
    YUPService.prototype.attachToast = function (component, containerComponent, containerRef, data) {
        var toastRef = new toast_ref_1.ToastRef(containerRef, containerComponent);
        var injector = this.createToastInjector(data, toastRef, containerComponent);
        if (containerComponent.attachComponent) {
            var contentRef = containerComponent.attachComponent(component, injector);
            toastRef.componentInstance = contentRef.instance;
        }
        return toastRef;
    };
    YUPService.prototype.attachLoad = function (component, containerComponent, containerRef, data) {
        var loadRef = new load_ref_1.LoadRef(containerRef, containerComponent);
        var injector = this.createLoadInjector(data, loadRef, containerComponent);
        if (containerComponent.attachComponent) {
            var contentRef = containerComponent.attachComponent(component, injector);
            loadRef.componentInstance = contentRef.instance;
        }
        return loadRef;
    };
    YUPService.prototype.createContainerComponent = function (containerRef, containerComponent, containerConfig) {
        var container = containerRef.createComponent(containerComponent, containerConfig);
        return container.instance;
    };
    YUPService.prototype.createDialogInjector = function (config, popupRef, dialogContainer) {
        if (config === void 0) { config = {}; }
        var injectionTokens = new WeakMap();
        injectionTokens.set(dialog_ref_1.DialogRef, popupRef);
        injectionTokens.set(container_2.DialogContainerComponent, dialogContainer);
        injectionTokens.set(common_1.DIALOG_DATA, config);
        return new common_1.PortalInjector(this.injector, injectionTokens);
    };
    YUPService.prototype.createToastInjector = function (config, popupRef, toastContainer) {
        if (config === void 0) { config = {}; }
        var injectionTokens = new WeakMap();
        injectionTokens.set(toast_ref_1.ToastRef, popupRef);
        injectionTokens.set(container_3.ToastContainerComponent, toastContainer);
        injectionTokens.set(common_1.TOAST_DATA, config);
        return new common_1.PortalInjector(this.injector, injectionTokens);
    };
    YUPService.prototype.createLoadInjector = function (config, popupRef, loadContainer) {
        if (config === void 0) { config = {}; }
        var injectionTokens = new WeakMap();
        injectionTokens.set(load_ref_1.LoadRef, popupRef);
        injectionTokens.set(container_4.LoadContainerComponent, loadContainer);
        injectionTokens.set(common_1.LOAD_DATA, config);
        return new common_1.PortalInjector(this.injector, injectionTokens);
    };
    YUPService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [container_1.Container,
            core_1.Injector])
    ], YUPService);
    return YUPService;
}());
exports.YUPService = YUPService;
//# sourceMappingURL=service.js.map