import { ComponentFactoryResolver, Injector, ViewContainerRef, EventEmitter, ChangeDetectorRef, ComponentRef } from '@angular/core';
import { ComponentType } from '../base/common';
export declare class ToastContainerComponent {
    private viewContainerRef;
    private componentFactoryResolver;
    private changeDetectorRef;
    animationStateChange: EventEmitter<AnimationEvent>;
    _state: 'void' | 'enter' | 'exit';
    private isAnimating;
    private disposeFn;
    private host;
    constructor(viewContainerRef: ViewContainerRef, componentFactoryResolver: ComponentFactoryResolver, changeDetectorRef: ChangeDetectorRef);
    attachComponent<T>(component: ComponentType<T>, injector: Injector): ComponentRef<T>;
    _onAnimationDone(event: AnimationEvent): void;
    _onAnimationStart(event: AnimationEvent): void;
    _startExitAnimation(): void;
}
