"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var container_host_1 = require("../base/container-host");
var animations_1 = require("../animations");
var ToastContainerComponent = (function () {
    function ToastContainerComponent(viewContainerRef, componentFactoryResolver, changeDetectorRef) {
        this.viewContainerRef = viewContainerRef;
        this.componentFactoryResolver = componentFactoryResolver;
        this.changeDetectorRef = changeDetectorRef;
        this.animationStateChange = new core_1.EventEmitter();
        this._state = 'enter';
        this.isAnimating = false;
    }
    ToastContainerComponent.prototype.attachComponent = function (component, injector) {
        return this.host.attachComponent(component, injector);
    };
    ToastContainerComponent.prototype._onAnimationDone = function (event) {
        this.animationStateChange.emit(event);
        this.isAnimating = false;
    };
    ToastContainerComponent.prototype._onAnimationStart = function (event) {
        this.isAnimating = true;
        this.animationStateChange.emit(event);
    };
    ToastContainerComponent.prototype._startExitAnimation = function () {
        this._state = 'exit';
        this.changeDetectorRef.markForCheck();
    };
    __decorate([
        core_1.ViewChild(container_host_1.ContainerHostDirective),
        __metadata("design:type", container_host_1.ContainerHostDirective)
    ], ToastContainerComponent.prototype, "host", void 0);
    ToastContainerComponent = __decorate([
        core_1.Component({
            template: "\n        <div class=\"yeui-toast-body\" [@toast]=\"_state\" (@toast.start)=\"_onAnimationStart($event)\" (@toast.done)=\"_onAnimationDone($event)\">\n            <ng-template yupHost></ng-template>\n        </div>\n    ",
            styles: ["\n        .yeui-toast-body {\n            position: fixed;\n            max-width: 300px;\n            max-height: 500px;z-index: 99;\n            overflow: hidden;text-align: center;padding: 0.5em 1.3em;\n            font-size: 16px;color: #fff;background: #000;opacity: 0.8;\n            bottom: 10%;left: 50%;border-radius: 3px;\n        }\n    "],
            encapsulation: core_1.ViewEncapsulation.None,
            changeDetection: core_1.ChangeDetectionStrategy.Default,
            animations: [animations_1.toast]
        }),
        __metadata("design:paramtypes", [core_1.ViewContainerRef,
            core_1.ComponentFactoryResolver,
            core_1.ChangeDetectorRef])
    ], ToastContainerComponent);
    return ToastContainerComponent;
}());
exports.ToastContainerComponent = ToastContainerComponent;
//# sourceMappingURL=container.js.map