"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Observable_1 = require("rxjs/Observable");
var Subject_1 = require("rxjs/Subject");
require("rxjs/add/observable/from");
require("rxjs/add/operator/filter");
var uniqueId = 0;
var ToastRef = (function () {
    function ToastRef(containerRef, containerComponent, id) {
        if (id === void 0) { id = "yup-toast-" + uniqueId++; }
        var _this = this;
        this.containerRef = containerRef;
        this.containerComponent = containerComponent;
        this.id = id;
        this.afterClosed = new Subject_1.Subject();
        Observable_1.Observable.from(containerComponent.animationStateChange)
            .filter(function (event) { return event.phaseName === 'done' && event.toState === 'exit'; })
            .subscribe(function () {
            _this.containerRef.removeComponent();
            _this.afterClosed.next(_this.result);
            _this.afterClosed.complete();
            _this.componentInstance = null;
        });
    }
    ToastRef.prototype.close = function (result) {
        this.result = result;
        Observable_1.Observable.from(this.containerComponent.animationStateChange)
            .filter(function (event) { return event.phaseName === 'start'; })
            .subscribe();
        this.containerComponent._startExitAnimation();
    };
    ToastRef.prototype.afterClose = function () {
        return this.afterClosed.asObservable();
    };
    return ToastRef;
}());
exports.ToastRef = ToastRef;
//# sourceMappingURL=toast.ref.js.map